/*****************************************************************************/
/*                                                                           */
/* FILENAME                                                                  */
/* 	 main.c                                                                  */
/*                                                                           */
/* DESCRIPTION                                                               */
/*   TMS320C5515 USB Stick Application 20 Spectrum Analyser.                 */
/*   Take microphone input and send to headphones with ring modulation.      */
/*                                                                           */
/* REVISION                                                                  */
/*   Revision: 1.00	                                                         */
/*   Author  : Richard Sikora                                                */
/*---------------------------------------------------------------------------*/
/*                                                                           */
/* HISTORY                                                                   */
/*   Revision: 1.00                                                          */
/*   15th September 2010. Created from TMS320C5505 USB Stick code.           */
/*                                                                           */
/*****************************************************************************/
/*
 * Copyright (C) 2010 Texas Instruments Incorporated - http://www.ti.com/ 
 * 
 * 
 *  Redistribution and use in source and binary forms, with or without 
 *  modification, are permitted provided that the following conditions 
 *  are met:
 *
 *    Redistributions of source code must retain the above copyright 
 *    notice, this list of conditions and the following disclaimer.
 *
 *    Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the 
 *    documentation and/or other materials provided with the   
 *    distribution.
 *
 *    Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
 *  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
 *  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 *  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 *  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
 *  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
*/

#include "stdio.h"
#include "usbstk5515.h"
#include "usbstk5515_led.h"
#include "aic3204.h"
#include "PLL.h"
//#include "bargraph.h"
#include "oled.h"
#include "pushbuttons.h"
#include "stereo.h"
#include "dsplib.h"


#include <stdio.h>
#include <stdlib.h>

#include "ETSI_nlms.h"

LMS lmsObj;
LMS *lms = &lmsObj;

short w[L+1];
short x[L+1];

// koniec adaptacyjnych


DATA bufor[L + 2];

Int16 left_input;
Int16 right_input;
Int16 left_output;
Int16 right_output;
Int16 mono_input;


#define SAMPLES_PER_SECOND 48000
#define GAIN_IN_dB 0

//unsigned long int i = 0;

unsigned int Step = 0; 
unsigned int LastStep = 99;

int i = 0;
int stara = 0;

//int j = 0;
//int k = 0;
//int m = 0;
//int display_counter = 0;
//int waveform_counter;
//long delay;

//DATA input_buffer[1024]; /* Must be declared as DATA for dsplib compatibility */

//DATA buffer2[1024];
//int display_buffer[96];
//int buffer1[96];

 
/* ------------------------------------------------------------------------ *
 *                                                                          *
 *  main( )                                                                 *
 *                                                                          *
 * ------------------------------------------------------------------------ */
void main( void ) 
{
	FILE   *plik;
    /* Initialize BSL */
    USBSTK5515_init( );
	
	/* Initialize PLL */
	pll_frequency_setup(120);

    /* Initialise hardware interface and I2C for code */
    aic3204_hardware_init();
    
    /* Initialise the AIC3204 codec */
	aic3204_init(); 
	
	/* Turn off the 4 coloured LEDs */
	USBSTK5515_ULED_init();
	
	/* Initialise the OLED LCD display */
	oled_init();
	SAR_init();
	/* Flush display buffer */
    oled_display_message("                 ", "                   ");
    oled_display_message("Cwiczenie 1      ", "Transmisja sygnalu ");
    
    printf("\n\nLaboratorium CPS\n");
    printf("Badanie filtrów adaptacyjnych\n" );
    printf("Filtr unormowany NLMS - ETSI\n" );
    
    printf("\n1. Transmisja sygnału z wejścia na wyjście");
    printf("\n2. Badanie filtru predykcyjnego - obserwacje przebiegów czasowych");
    printf("\n3. Badanie filtru predykcyjnego - pomiar czarakterystyki amplitudowej repliki filtru");
    printf("\n4. Badanie filtru predykcyjnego - zapisanie w m-pliku chwilowejodpowiedzi imulusowej filtru\n");
      
    set_sampling_frequency_and_gain(16000, GAIN_IN_dB);


	/* Setup sampling frequency and  gain for microphone */
    //set_sampling_frequency_and_gain(SAMPLES_PER_SECOND, GAIN_IN_dB);

    
      
	/* Default to XF LED off */
	asm(" bclr XF");
	
	
	// Initialize adaptive system identificaiton object
 lms->order = L;
  lms->alpha = ALPHA;
  lms->power = (short)0x32767;
  lms->c = C;
  lms->w = w;
  lms->x = x;	     

  for (i=0; i<L; i++)
  {
    w[i] = 0;          // Initialize adaptive filter coefficients  
    x[i] = 0;          // Initialize adaptive filter delay-line  
  }
	
	
	
	
	
	
    
 	for ( ;; )
 	{

     aic3204_codec_read(&left_input, &right_input); // Configured for one interrupt per two channels.
   
     mono_input = stereo_to_mono(left_input, right_input);
     
     Step = pushbuttons_read(4);
         
	  if ( Step == 1 )
        {
         if ( Step != LastStep )
          {
           oled_display_message("Zwarcie              ", "FP = 8 KHZ       "); 
           printf("\n1. Transmisja sygnału z wejścia na wyjście"); 
           printf("\nZwarcie\n");
           // set_sampling_frequency_and_gain(16000, GAIN_IN_dB);
           LastStep = Step;
          }	
         left_output = left_input;      // Straight trough. No processing.
	     right_output = right_input;

	    } 
	  if ( Step == 2)
        {
         if ( Step != LastStep )
          {
           oled_display_message("Zwarcie              ", "FP = 16 KHZ           ");
               printf("\n2. Badanie filtru predykcyjnego - obserwacje przebiegów czasowych");
            printf("\nKanał lewy zwarcie\nKanał prawy predyktor\n");   
           //set_sampling_frequency_and_gain(16000, GAIN_IN_dB);
           LastStep = Step;
           for (i=0; i<L; i++)
			  {
			    w[i] = 0;          // Initialize adaptive filter coefficients  
			    x[i] = 0;          // Initialize adaptive filter delay-line  
			  }
          }	
          
          
         left_output =  left_input;
                 
         lms->in  = stara;
         stara = lms->des = left_input;
    		
   		intrinsic_nlms(lms);	
         
         
	     right_output = lms->out;

	    } 
      if ( Step == 3)
        {
         if ( Step != LastStep )
          {
           oled_display_message("Zwarcie              ", "FP = 24 KHZ           ");
           printf("\n3. Badanie filtru predykcyjnego - pomiar czarakterystyki amplitudowej repliki filtru");
            printf("\nKanał lewy predykcja \n Kanal prawy FIR\n"); 
           //set_sampling_frequency_and_gain(16000, GAIN_IN_dB);
           LastStep = Step;
           for (i=0; i<L; i++)
			  {
			    w[i] = 0;          // Initialize adaptive filter coefficients  
			    x[i] = 0;          // Initialize adaptive filter delay-line  
			  }
			  stara = 0;
          }	
          
         lms->in  = stara;
         stara = lms->des = left_input;
    		
   		intrinsic_nlms(lms);	
         
         
	     left_output = lms->out;
         
         fir(&right_input, w, &right_output, bufor, 1, L);
         

	    } 
	   if ( Step == 4)
        {
         if ( Step != LastStep )
          {
           oled_display_message("Zwarcie              ", "FP = 48 KHZ           ");
           printf("\n4. Badanie filtru predykcyjnego - zapisanie w m-pliku chwilowejodpowiedzi imulusowej filtru\n");
           
			if ((plik = fopen("..\\mpliki\\filtr.m", "w"))== NULL)
			{
			    printf("Can't open input data file\n");
			    exit(0);
			}
			fprintf(plik, "b = ["); 
			
			for (i=0; i<L; i++)
			    fprintf(plik, "%d\n", w[i]);          // zapis odpowiedzi impulsowej w pliku  			    

			fprintf(plik, "];\n b=b./2^15;\nfvtool(b)"); 			
			fclose(plik);

           LastStep = Step;
          }	
         left_output = left_input;      // Straight trough. No processing.
	     right_output = right_input;

	    } 
	    
     aic3204_codec_write(left_output, right_output);

 	}

   /* Disable I2S and put codec into reset */ 
    aic3204_disable();

    printf( "\n***Program has Terminated***\n" );
    
    oled_display_message("PROGRAM HAS        ", "TERMINATED        ");
    
    SW_BREAKPOINT;
}

/* ------------------------------------------------------------------------ *
 *                                                                          *
 *  End of main.c                                                           *
 *                                                                          *
 * ------------------------------------------------------------------------ */
